import * as wjcCore from '@grapecity/wijmo';
import * as wjcGrid from '@grapecity/wijmo.grid';

import { Component, ViewChild } from '@angular/core';
import {FooterMergeManager}  from './FooterRowMerge'

@Component({
  selector: 'my-app',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  source;
  constructor() {
    this.source = this.getData();
  }
  @ViewChild('grid') grid : wjcGrid.FlexGrid; 
  formatItem(grid,e){
    if(grid.columns[e.col].binding =="year"){
      return;
    }
    if(e.panel.cellType==1 ){
      if(!grid.rows[e.row].dataItem && grid.columns[e.col].binding != 'sales'){
        e.cell.innerHTML = "Custom";
      }
    }
  }
  getParent(rowIndex){
    for(let i=rowIndex;i>=0;i--){
      if((this.grid.rows[i] as wjcGrid.GroupRow).hasChildren){
        return i;
      }
    }
  }
  initGrid(grid,e){
    let text="";
    for(let i=0;i<grid.rows.length;i++){
      if(grid.rows[i].hasChildren && grid.rows[i].dataItem){
        let agg= wjcCore.getAggregate(wjcCore.Aggregate.Sum,grid.rows[i].dataItem[grid.childItemsPath],'sales');
        text = agg == 0 ? "Custom" : wjcCore.Globalize.formatNumber(agg,'n2');
      }
      if(!grid.rows[i].dataItem){
        console.log(i,text)
        grid.setCellData(i,'sales',text);
      }
    }
    grid.mergeManager = new FooterMergeManager(grid);
  }
  loadedRows(grid,e){
    for(let i = grid.rows.length-1 ; i >= 0 ; i--){
      if(grid.rows[i].hasChildren && i-2 >0){
        grid.rows.insert(i,new wjcGrid.GroupRow());
        grid.rows.insert(i,new wjcGrid.GroupRow());
        grid.rows.insert(i,new wjcGrid.GroupRow());
      }
    }
    grid.rows.push(new wjcGrid.GroupRow());
    grid.rows.push(new wjcGrid.GroupRow());
    grid.rows.push(new wjcGrid.GroupRow());
    grid.collapseGroupsToLevel(0);
  }
  getData() {
    var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','), data = [];
    var product = "Wijmo,C1,Spread,ActiveReport".split(',');

    for(let i=0;i<5;i++){
      var item = {name:countries[i%countries.length], year:new Date().getFullYear()+i};
      item['product'] = [];
      for(let j=0;j<product.length;j++){
        item['product'].push({
            productId: i+j,
            name: product[j],
            sales:Math.random()*100
        });
      }
      data.push(item);
    }
    return data;
  }
}